# class SignallingDumper | A generic data dumper. More...
Full name | `TelEngine::SignallingDumper`
Definition | `#include <libs/ysig/yatesig.h>`
List of all Methods
Annotated List
Files
Globals
Hierarchy
Index

#### Public Types

- enum Type { Raw, Hexa, Hdlc, Q921, Q931, Mtp2, Mtp3, Sccp, }

#### Public Methods

- SignallingDumper (Type type = Hexa, bool network = false)
- ~SignallingDumper ()
- inline Type type () const
- inline bool network () const
- bool active () const
- void terminate ()
- void setStream (Stream* stream = 0, bool writeHeader = true)
- bool dump (void* buf, unsigned int len, bool sent = false, int link = 0)
- inline bool dump (const DataBlock& data, bool sent = false, int link = 0)

#### Public Static Methods

- static SignallingDumper* create (DebugEnabler* dbg, const char* filename, Type type, bool network = false, bool create = true, bool append = false)
- static SignallingDumper* create (Stream* stream, Type type, bool network = false, bool writeHeader = true)

## Detailed Description

This class is a generic data dumper with libpcap compatibility

enum Type { Raw, Hexa, Hdlc, Q921, Q931, Mtp2, Mtp3, Sccp, } | ### Type

Type of dumper output

SignallingDumper (Type type = Hexa, bool network = false) | ### SignallingDumper

Constructor

Parameters:

type | Type of the output desired
network | True if we are the network side of the link

~SignallingDumper () | ### ~SignallingDumper

Destructor, closes the output

inline Type type () | ### type

[const]

Get the type of the dumper

Returns: Type of the dumper object

inline bool network () | ### network

[const]

Get the network side flag

Returns: True if we are the network side

bool active () | ### active

[const]

Check if the dumper is active

Returns: True if the object will actually send data to something

void terminate () | ### terminate

Terminate the dump session, close the output

void setStream (Stream* stream = 0, bool writeHeader = true) | ### setStream

Set a new output stream

Parameters:

stream | New stream for output, NULL to terminate
writeHeader | True to write the header (if any) at start of stream

bool dump (void* buf, unsigned int len, bool sent = false, int link = 0) | ### dump

Dump the provided data

Parameters:

buf | Pointer to buffer to dump
len | Length of the data
sent | True if data is being sent, false if is being received
link | Link number (relevant to MTP2 only)

Returns: True if the data was dumped successfully

inline bool dump (const DataBlock& data, bool sent = false, int link = 0) | ### dump

Dump the provided data

Parameters:

data | Buffer to dump
sent | True if data is being sent, false if is being received
link | Link number (relevant to MTP2 only)

Returns: True if the data was dumped successfully

SignallingDumper* create (DebugEnabler* dbg, const char* filename, Type type, bool network = false, bool create = true, bool append = false) | ### create

[static]

Create a file to dump data in it. The file is opened/created in write only, binary mode

Parameters:

dbg | DebugEnabler requesting the operation (used for debug message on failure)
filename | The file name to use
type | The dumper type
network | True to create a network side dumper
create | True to create the file if doesn't exist
append | Append to an existing file. If false and the file already exists, it will be truncated

Returns: SignallingDumper pointer on success, 0 on failure

SignallingDumper* create (Stream* stream, Type type, bool network = false, bool writeHeader = true) | ### create

[static]

Create a dumper from an already existing stream

Parameters:

stream | Stream to use for output, will be owned by dumper
type | The dumper type
network | True to create a network side dumper
writeHeader | True to write the header (if any) at start of stream

Returns: SignallingDumper pointer on success, 0 on failure

Generated by: paulc on bussard on Mon Feb 10 13:15:47 2014, using kdoc 2.0a54.